
import java.util.*;
public class Probleme
{
    public static void main(String args[])
    {
    }
}

// Classe de dfinition d'un rpertoire tlphonique
//
class Repertoire
{
    // Le rpertoire est une litse de contacts
    ArrayList<Contact> contacts;
    
    // Constructeur pour cr la liste vide
    public Repertoire()
    {
        contacts = new ArrayList<Contact>();
    }

    // Ajouter un nouveau contact
    public void ajouterContact(String nom, String intitule, String numero)
    {
        Contact c = new Contact(nom);
        c.addNumero(intitule,numero);
        contacts.add(c);
    }

    // Ajouter un nouveau numero a un contact existant
    public void ajouterNumero(String nom, String intitule, String numero)
    {
        Contact c = rechercherContact(nom);
        if (c==null)
            System.out.println("Le contat " + nom + " n'existe pas");
        else
            c.addNumero(intitule,numero);
    }

    // Modifier un de snumeros d'un contact
    public void modifierNumero(String nom, String intitule, String numero)
    {
        Contact c = rechercherContact(nom);
        if (c==null)
            System.out.println("Le contat " + nom + " n'existe pas");
        else
            c.modifierNumero(intitule,numero);
    }

    // Recherhce un contact en fonction de son nom
    public Contact rechercherContact(String nom)
    {
        for(Contact c:contacts)
            if (c.nom.equals(nom)) return(c);
        return(null);
    }

    // Retourne tous les numeros d'un contact donn
    public String[] getNumeros(String nom)
    {
        Contact c = rechercherContact(nom);
        if (c==null)
        {
            System.out.println("Le contat " + nom + " n'existe pas");
            return null;
        }
        else
        {
            String[] tab = new String[c.numeros.size()];
            return c.numeros.toArray(tab);
        }
    }

    // Affiche tous les contacts par ordre alphabetique
    public void afficher()
    {
        Collections.sort(contacts);
        for(Contact c:contacts)
            c.afficher();
    }

}

// Classe de dfinition d'un contact
//
class Contact implements Comparable<Contact>
{
    // Le nom du contact
    String nom;

    // Les numeros du contact : liste de chaine
    ArrayList<String> numeros = new ArrayList<String>();

    // Constructeur qui cre un contact avec une liste vide de numro
    public Contact(String nom)
    {
        this.nom=nom;
        numeros = new ArrayList<String>();
    }

    // Ajoute un nouveau numero
    public void addNumero(String intitule,String numero)
    {
        numeros.add(intitule+"/"+numero);
    }

    // Modifie un des numeros en fonction de son intitul
    public void modifierNumero(String intitule, String numero)
    {
        for(int i=0;i<numeros.size();i++)
            {
                String num = numeros.get(i);
                String[] t = num.split(":");
                if (t[0].equals(intitule))
                    {
                        numeros.set(i,intitule+"/"+numero);
                        break;
                    }
            }
    }

    // Methode d'implmentation de Comparable
    // Utilis pour trier.
    // L'ordre de tri est le nom du contact
    public int compareTo(Contact c)
    {
        return this.nom.compareTo(c.nom);
    }

    // Affiche un contact
    public void afficher()
    {
        System.out.println(nom);
        for(String num:numeros)
            System.out.println("   " + num);
        System.out.println("-----------------------");
    }

}

